<?php
/*
Weather Web Cam Images History and Template Plugin PHP Script
PHP script by Mike Challis, www.642weather.com/weather/scripts.php
Download: http://www.642weather.com/weather/scripts/web-cam-history.zip
Info: http://www.642weather.com/weather/scripts-weather-cam-history.php
Contact Mike - http://www.642weather.com/weather/contact_us.php

Version: 1.02  04-Nov-2009 see changelog.txt for changes

You are free to use and modify the code

This php code provided "as is", and Long Beach Weather (Michael Challis)
disclaims any and all warranties, whether express or implied, including
(without limitation) any implied warranties of merchantability or
fitness for a particular purpose.

Copyright (C) 2008 Mike Challis  (http://www.642weather.com/weather/contact_us.php)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

PHP version 4.3.9 or greater is recommended
NOTE: This script requires PHP installed using GD image support.
http://us2.php.net/manual/en/ref.image.php

*/
$cam_history_version = 'Version: 1.02 - 04-Nov-2009 - cam-history.php';

###############
# begin settings
###############
/*
Supports cam images and thumbnails in this format
where 0 is the newest and 2 is the oldest.

webcamimage0.jpg
webcamimage0-thm.jpg
webcamimage1.jpg
webcamimage1-thm.jpg
webcamimage2.jpg
webcamimage2-thm.jpg
*/

$page_title            = 'Weather Cam Archives'; # used in beginning of page title
$page_title_site       = ''; # also used at end of page title, ie: 'Long Beach Weather - Long Beach, WA USA'
$cam_title             = 'Web Cam Image';     # for the alt tags
$cam_dir               = './webcam/';         # folder where the web cam images are WITH slash on end
$image_url_path        = './webcam';          # URL folder where the images are, WITHOUT slash on end!
$script_url            = '.';                 # URL folder where this script is, WITHOUT slash on end!
$script_name           = 'wxcam-history.php'; # name of your web cam history page, incase you change it
$viewer_script_name    = 'cam-view.php';      # name of the viewer script file, incase you change it
$prefix                = 'webcamimage';       # because I use webcamimage0.jpg webcamimage0-thm.jpg
$ext                   = 'jpg';               # my file extension is jpg
$thumb_width           = 100;                 # how wide the thum images are
$thum_per_row          = 6;
$rows_per_page         = 20;
$delay                 = 60; # seconds of delay between when the image is taken and when the image is saved on the server.
             # setting this correctly will syncronize the
             # cam image times displayed on this page to the actual timestamp on your cam image

$disable_refresh_at_night = 1; # set to 0 for on, or 1 for off
   # normally there is a 5 minute meta refresh in the daytime to keep the 1st image current
   # because my cam does not upload at night I like to disable the meta page refresh at night.
   # this feature requires including testtags.php
   # if you set this to 1: $testtags_path must be set correctly,
   # and your testtags.php file must contain the  $dayornight tag
   # if it does not, edit the template in your wdisplay/webfiles folder and add this line to it:
   # $dayornight       = '%dayornight%';
   # if you do not have a testtags.php set this setting to 0
   # Note: your testtags.php file must contain the  $dayornight tag

$testtags_path = './testtags.php';


###############
# end settings
###############

$dayornight = 'Day';
$disable_refresh_at_night and include_once $testtags_path;

 # put all the images into a list
  if(is_dir($cam_dir)){
    if($handle = opendir($cam_dir)){
      while(($file = readdir($handle)) !== false){
         if(preg_match("/^$prefix([0-9]*)-thm.$ext$/i",$file,$matches)){
           $filesarray["$matches[1]"] = $file;
        }
      }
      closedir($handle);
    }
  }

  # count and sort the list
 $count = 0;
 $count = count($filesarray); # 0 is 1, 1 is 2

 if ($count > 0) {
   ksort($filesarray);
   $lic = $count -1;
   $start_image_time = date ("D, m/d/Y g:ia T", filemtime("$cam_dir$filesarray[0]")-$delay);
   $end_image_time   = date ("D, m/d/Y g:ia T", filemtime("$cam_dir$filesarray[$lic]")-$delay);

   # calculate how many pages based on number of images and rows * cols
   $pages = 0;
   $per_page = $thum_per_row * $rows_per_page;
   $pages = $count/$per_page;

   # what page are we on now?
   $this_page = 1;
   if(isset($_GET['page']) && preg_match("/^[0-9]+$/", $_GET['page']) && $_GET['page'] <= ceil($pages)){
     $this_page = $_GET['page'];
   }

   # make the page menu html
   if($pages > 1)  $menu_html = "Go to page&nbsp;";
   if(ceil($pages) == 1) $menu_html = "Page $this_page of&nbsp;";
   $page = 1;
   $menu_file = $script_url;
   for ($i = $pages; $i > 0; $i--) {
       if ($page == $this_page) {
             $menu_html .= "$page&nbsp;";
       }else{
             $menu_html .= "<a href=\"$script_url/$script_name?page=$page\">$page</a>&nbsp;";
       }
       $page++;
   }

   # make the table cells html
   $countline = 0;
   // because image starts at zero, the next two lines prevents 1001
   $count = $count -1;
   $file_skipped = array_pop($filesarray);
 
   foreach ($filesarray as $k => $v) {
      $countline++;
      if( $this_page > 1 && ($countline <= ($per_page * ($this_page -1))) ) continue;
      $rowstart=0;
      $rowstart = (($countline - 1) % $thum_per_row);
      if ($rowstart == 0) {
         # begin of row everytime necessary
         $string .= '<tr>
         ';
      }
      if (file_exists("$cam_dir$prefix$k.$ext")) {
              $timestat = date ("D, m/d/Y g:ia T", filemtime("$cam_dir$prefix$k.$ext")-$delay);
      } else {
              $timestat = 'missing file';
      }
      $string .= "<td valign=\"top\" width=\"$thumb_width\"><div align=\"center\">";
      if($timestat != 'missing file') {
        $string .= "<a href=\"$script_url/$viewer_script_name?pic=$countline\" onclick=\"photoView(this.href); return false;\">
        <img border=\"0\" src=\"$image_url_path/$prefix$k-thm.$ext?dontcache=".time()."\" alt=\"$cam_title - $timestat\" title=\" $cam_title - $timestat \" /></a>";
      }
      $string .= "<br />
         <small>$timestat</small><br /><br />
         </div></td>
      ";
      if ($countline % $thum_per_row == 0) {
        # end of row everytime count is at thum_per_row
        $string .= '</tr>
        ';
      }
      if ($countline % $thum_per_row != 0 && $countline == $count) { # last image
         $leftover = $countline % $thum_per_row;
         # fill in any left over row slots to keep table looking nice
         for ($i = $thum_per_row - $leftover; $i > 0; $i--) {
             $string .= '<td>&nbsp;</td>
             ';
         }
         $string .= '</tr>
         ';
      }
      if($this_page == 1 && $countline > $per_page -1) break;
      if( $this_page > 1 && ($countline > ($per_page -1 + ($per_page * ($this_page -1)))) ) break;
   } # end foreach

   $output_content =  '<p align="left">Images archive every 5 minutes';
   if($disable_refresh_at_night == 1){
     $output_content .=  ' during daylight hours only.<br />';

   } else {
       $output_content .=  '<br />';
   }
   $output_content .= "Archive contains $lic images from $start_image_time - $end_image_time" .'</p>';

   $output_content .= "<p align=\"left\">$menu_html</p>";
   $output_content .= '<table width="610" align="center" border="0" cellpadding="0" cellspacing="4">';
   $output_content .= $string . '</table>';
   $output_content .= "<p align=\"right\">$menu_html</p>
   ";

}else{ # else for if ($count > 0)
      $output_content .= '<p>No web cam images archived, please come back later.</p>
      ';
}

$output_content .= "<!-- $cam_history_version -->\n";
$output_content .= "<!-- http://www.642weather.com/weather/scripts.php -->\n\n";

# $header_insert should be included in your page head like this:
$header_title = '<title>'.$page_title.' - Page '.$this_page.' - from '.$page_title_site.'</title>'."\n";
$header_description = '<meta name="description" content="'.$page_title.' - Page '.$this_page.' - from '.$page_title_site.'." />'."\n";
if($dayornight != 'Night') {
 $header_insert .= '<meta http-equiv="Refresh" content="300" />'."\n";
}

$header_insert .= '<script type="text/javascript" language="JavaScript">
function photoView(url) {
  window.open(url,"view_photo","height=600,width=700,toolbar=no,statusbar=no,scrollbars=yes").focus();
}
</script>
';

?>
